diff --git a/src/test/regress/sql/window.sql b/src/test/regress/sql/window.sql
index 7297e62..117bd6c 100644
*** a/src/test/regress/sql/window.sql
--- b/src/test/regress/sql/window.sql
*************** SELECT nth_value_def(n := 2, val := ten)
*** 284,286 ****
--- 284,489 ----
  
  SELECT nth_value_def(ten) OVER (PARTITION BY four), ten, four
    FROM (SELECT * FROM tenk1 WHERE unique2 < 10 ORDER BY four, ten) s;
+ 
+ --
+ --
+ -- Test the basic inverse transition function machinery
+ --
+ --
+ 
+ -- create aggregates which log their calls
+ -- invsfunc is *not* a real inverse here!
+ CREATE FUNCTION logging_sfunc_nonstrict(text, anyelement) RETURNS text AS
+ $$SELECT COALESCE($1, '') || '+' || quote_nullable($2)$$
+ LANGUAGE SQL IMMUTABLE;
+ 
+ CREATE FUNCTION logging_invsfunc_nonstrict(text, anyelement) RETURNS text AS
+ $$SELECT $1 || '-' || quote_nullable($2)$$
+ LANGUAGE SQL IMMUTABLE;
+ 
+ CREATE AGGREGATE logging_agg_nonstrict (anyelement)
+ (
+ 	stype = text,
+ 	sfunc = logging_sfunc_nonstrict,
+ 	invsfunc = logging_invsfunc_nonstrict
+ );
+ 
+ CREATE AGGREGATE logging_agg_nonstrict_initcond (anyelement)
+ (
+ 	stype = text,
+ 	sfunc = logging_sfunc_nonstrict,
+ 	invsfunc = logging_invsfunc_nonstrict,
+ 	initcond = 'I'
+ );
+ 
+ CREATE FUNCTION logging_sfunc_strict(text, anyelement) RETURNS text AS
+ $$SELECT $1 || '+' || quote_nullable($2)$$
+ LANGUAGE SQL STRICT IMMUTABLE;
+ 
+ CREATE FUNCTION logging_invsfunc_strict(text, anyelement) RETURNS text AS
+ $$SELECT $1 || '-' || quote_nullable($2)$$
+ LANGUAGE SQL STRICT IMMUTABLE;
+ 
+ CREATE AGGREGATE logging_agg_strict (text)
+ (
+ 	stype = text,
+ 	sfunc = logging_sfunc_strict,
+ 	invsfunc = logging_invsfunc_strict
+ );
+ 
+ CREATE AGGREGATE logging_agg_strict_initcond (anyelement)
+ (
+ 	stype = text,
+ 	sfunc = logging_sfunc_strict,
+ 	invsfunc = logging_invsfunc_strict,
+ 	initcond = 'I'
+ );
+ 
+ -- test strict and non-strict cases
+ SELECT
+ 	p::text || ',' || i::text || ':' || COALESCE(v::text, 'NULL') AS row,
+ 	logging_agg_nonstrict(v) over wnd as nstrict,
+ 	logging_agg_nonstrict_initcond(v) over wnd as nstrict_init,
+ 	logging_agg_strict(v::text) over wnd as strict,
+ 	logging_agg_strict_initcond(v) over wnd as strict_init
+ FROM (VALUES
+ 	(1, 1, NULL),
+ 	(1, 2, 'a'),
+ 	(1, 3, 'b'),
+ 	(1, 4, NULL),
+ 	(1, 5, NULL),
+ 	(1, 6, 'c'),
+ 	(2, 1, NULL),
+ 	(2, 2, 'x'),
+ 	(3, 1, 'z')
+ ) AS t(p, i, v)
+ WINDOW wnd AS (PARTITION BY P ORDER BY i ROWS BETWEEN 1 PRECEDING AND CURRENT ROW)
+ ORDER BY p, i;
+ 
+ -- and again, but with filter
+ SELECT
+ 	p::text || ',' || i::text || ':' ||
+ 		CASE WHEN f THEN COALESCE(v::text, 'NULL') ELSE '-' END as row,
+ 	logging_agg_nonstrict(v) filter(where f) over wnd as nstrict_filt,
+ 	logging_agg_nonstrict_initcond(v) filter(where f) over wnd as nstrict_init_filt,
+ 	logging_agg_strict(v::text) filter(where f) over wnd as strict_filt,
+ 	logging_agg_strict_initcond(v) filter(where f) over wnd as strict_init_filt
+ FROM (VALUES
+ 	(1, 1, true,  NULL),
+ 	(1, 2, false, 'a'),
+ 	(1, 3, true,  'b'),
+ 	(1, 4, false, NULL),
+ 	(1, 5, false, NULL),
+ 	(1, 6, false, 'c'),
+ 	(2, 1, false, NULL),
+ 	(2, 2, true,  'x'),
+ 	(3, 1, true,  'z')
+ ) AS t(p, i, f, v)
+ WINDOW wnd AS (PARTITION BY p ORDER BY i ROWS BETWEEN 1 PRECEDING AND CURRENT ROW)
+ ORDER BY p, i;
+ 
+ -- tests that volatile arguments disable inverse transition functions
+ SELECT
+ 	i::text || ':' || COALESCE(v::text, 'NULL') as row,
+ 	logging_agg_strict(v::text)
+ 		over wnd as inverse,
+ 	logging_agg_strict(v::text || CASE WHEN random() < 0 then '?' ELSE '' END)
+ 		over wnd as noinverse
+ FROM (VALUES
+ 	(1, 'a'),
+ 	(2, 'b'),
+ 	(3, 'c')
+ ) AS t(i, v)
+ WINDOW wnd AS (ORDER BY i ROWS BETWEEN 1 PRECEDING AND CURRENT ROW)
+ ORDER BY i;
+ 
+ -- tests that volatile filters disable inverse transition functions
+ SELECT
+ 	i::text || ':' || COALESCE(v::text, 'NULL') as row,
+ 	logging_agg_strict(v::text) filter(where true)
+ 		over wnd as inverse,
+ 	logging_agg_strict(v::text) filter(where random() >= 0)
+ 		over wnd as noinverse
+ FROM (VALUES
+ 	(1, 'a'),
+ 	(2, 'b'),
+ 	(3, 'c')
+ ) AS t(i, v)
+ WINDOW wnd AS (ORDER BY i ROWS BETWEEN 1 PRECEDING AND CURRENT ROW)
+ ORDER BY i;
+ 
+ -- test that non-overlapping windows don't use inverse transitions
+ SELECT
+ 	logging_agg_strict(v::text) OVER wnd
+ FROM (VALUES
+ 	(1, 'a'),
+ 	(2, 'b'),
+ 	(3, 'c')
+ ) AS t(i, v)
+ WINDOW wnd AS (ORDER BY i ROWS BETWEEN CURRENT ROW AND CURRENT ROW)
+ ORDER BY i;
+ 
+ -- test that returning NULL from the inverse transition functions
+ -- restarts the aggregation from scratch. The second aggregate is supposed
+ -- to test cases where only some aggregates restart, the third one checks
+ -- the one aggregate restarting doesn't cause others to restart
+ CREATE FUNCTION sum_int_randrestart_invsfunc(int4, int4) RETURNS int4 AS
+ $$SELECT CASE WHEN random() < 0.2 THEN NULL ELSE $1 - $2 END$$
+ LANGUAGE SQL STRICT IMMUTABLE;
+ 
+ CREATE AGGREGATE sum_int_randomrestart (int4)
+ (
+ 	stype = int4,
+ 	sfunc = int4pl,
+ 	invsfunc = sum_int_randrestart_invsfunc
+ );
+ 
+ WITH
+ vs AS (
+ 	SELECT i, (random() * 100)::int4 AS v
+ 	FROM generate_series(1, 100) AS i
+ ),
+ sum_following AS (
+ 	SELECT i, SUM(v) OVER
+ 		(ORDER BY i DESC ROWS BETWEEN UNBOUNDED PRECEDING AND CURRENT ROW) AS s
+ 	FROM vs
+ )
+ SELECT DISTINCT
+ 	sum_following.s = sum_int_randomrestart(v) OVER fwd AS eq1,
+ 	-sum_following.s = sum_int_randomrestart(-v) OVER fwd AS eq2,
+ 	100*3+(vs.i-1)*3 = length(logging_agg_nonstrict(''::text) OVER fwd) AS eq3
+ FROM vs
+ JOIN sum_following ON sum_following.i = vs.i
+ WINDOW fwd AS (
+ 	ORDER BY vs.i ROWS BETWEEN CURRENT ROW AND UNBOUNDED FOLLOWING
+ );
+ 
+ -- cleanup aggregates
+ DROP AGGREGATE sum_int_randomrestart (int4);
+ DROP FUNCTION sum_int_randrestart_invsfunc(int4, int4);
+ DROP AGGREGATE logging_agg_strict_initcond(anyelement);
+ DROP AGGREGATE logging_agg_strict(text);
+ DROP FUNCTION logging_invsfunc_strict(text, anyelement);
+ DROP FUNCTION logging_sfunc_strict(text, anyelement);
+ DROP AGGREGATE logging_agg_nonstrict_initcond(anyelement);
+ DROP AGGREGATE logging_agg_nonstrict(anyelement);
+ DROP FUNCTION logging_invsfunc_nonstrict(text, anyelement);
+ DROP FUNCTION logging_sfunc_nonstrict(text, anyelement);
+ 
+ --
+ --
+ -- Test the arithmetic inverse transition functions
+ --
+ --
+ 
+ --
+ --
+ -- Test the MIN, MAX and boolean inverse transition functions
+ --
+ --
+ 
+ --
+ --
+ -- Tests of the collecting inverse transition functions
+ --
+ --
